package io.dekorate.testing.openshift.config;

import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class OpenshiftIntegrationTestConfig{

    private boolean deployEnabled = true;
    private boolean buildEnabled = true;
    private long imageStreamTagTimeout = 120000;
    private long readinessTimeout = 300000;

    public OpenshiftIntegrationTestConfig(){
    }
    public OpenshiftIntegrationTestConfig(boolean deployEnabled,boolean buildEnabled,long imageStreamTagTimeout,long readinessTimeout){
            this.deployEnabled = deployEnabled;
            this.buildEnabled = buildEnabled;
            this.imageStreamTagTimeout = imageStreamTagTimeout;
            this.readinessTimeout = readinessTimeout;
    }

    public boolean isDeployEnabled(){
            return this.deployEnabled;
    }

    public boolean isBuildEnabled(){
            return this.buildEnabled;
    }

    public long getImageStreamTagTimeout(){
            return this.imageStreamTagTimeout;
    }

    public long getReadinessTimeout(){
            return this.readinessTimeout;
    }




}
