package io.dekorate.testing.openshift.config;

import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.Boolean;

public class OpenshiftIntegrationTestConfigFluentImpl<A extends OpenshiftIntegrationTestConfigFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements OpenshiftIntegrationTestConfigFluent<A>{

    private boolean deployEnabled = true;
    private boolean buildEnabled = true;
    private long imageStreamTagTimeout = 120000;
    private long readinessTimeout = 300000;

    public OpenshiftIntegrationTestConfigFluentImpl(){
    }
    public OpenshiftIntegrationTestConfigFluentImpl(OpenshiftIntegrationTestConfig instance){
            this.withDeployEnabled(instance.isDeployEnabled()); 
            this.withBuildEnabled(instance.isBuildEnabled()); 
            this.withImageStreamTagTimeout(instance.getImageStreamTagTimeout()); 
            this.withReadinessTimeout(instance.getReadinessTimeout()); 
    }

    public boolean isDeployEnabled(){
            return this.deployEnabled;
    }

    public A withDeployEnabled(boolean deployEnabled){
            this.deployEnabled=deployEnabled; return (A) this;
    }

    public Boolean hasDeployEnabled(){
            return true;
    }

    public boolean isBuildEnabled(){
            return this.buildEnabled;
    }

    public A withBuildEnabled(boolean buildEnabled){
            this.buildEnabled=buildEnabled; return (A) this;
    }

    public Boolean hasBuildEnabled(){
            return true;
    }

    public long getImageStreamTagTimeout(){
            return this.imageStreamTagTimeout;
    }

    public A withImageStreamTagTimeout(long imageStreamTagTimeout){
            this.imageStreamTagTimeout=imageStreamTagTimeout; return (A) this;
    }

    public Boolean hasImageStreamTagTimeout(){
            return true;
    }

    public long getReadinessTimeout(){
            return this.readinessTimeout;
    }

    public A withReadinessTimeout(long readinessTimeout){
            this.readinessTimeout=readinessTimeout; return (A) this;
    }

    public Boolean hasReadinessTimeout(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            OpenshiftIntegrationTestConfigFluentImpl that = (OpenshiftIntegrationTestConfigFluentImpl) o;
            if (deployEnabled != that.deployEnabled) return false;
            if (buildEnabled != that.buildEnabled) return false;
            if (imageStreamTagTimeout != that.imageStreamTagTimeout) return false;
            if (readinessTimeout != that.readinessTimeout) return false;
            return true;
    }




}
